Index: /trunk/SophyaPI/PI/Makefile
===================================================================
--- /trunk/SophyaPI/PI/Makefile	(revision 4082)
+++ /trunk/SophyaPI/PI/Makefile	(revision 4083)
@@ -1,3 +1,3 @@
-include ../BuildMgr/sophyamake.inc
+include ../sophyamake.inc
  
 all: $(SOPHYALIBP)libPI.a
Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 4082)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 4083)
@@ -331,4 +331,5 @@
 void PIGraphicQuartz::DrawMarker(PIGrCoord x0, PIGrCoord y0)
 {
+	printf("PIGraphicQuartz::DrawMarker   NOT IMPLEMENTED\n");
 
 /*
@@ -407,4 +408,5 @@
 void PIGraphicQuartz::DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n)
 {
+	printf("PIGraphicQuartz::DrawMarkers   NOT IMPLEMENTED\n");
 /*
 int i;
@@ -431,4 +433,8 @@
 
 
+void PIGraphicQuartz::DrawPixmap(PIGrCoord, PIGrCoord, PIPixColIdx&, PIColorMap*) {
+	printf("PIGraphicQuartz::DrawPixmap1   NOT IMPLEMENTED\n");
+}
+
 /* --Methode-- */
 void PIGraphicQuartz::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
@@ -470,4 +476,5 @@
 XFree(ximg);
 */
+	printf("PIGraphicQuartz::DrawPixmap2   NOT IMPLEMENTED\n");
 return;
 }
@@ -517,4 +524,5 @@
 void PIGraphicQuartz::DrawVerticalString(int x, int y, const char* s, unsigned long pos, bool imgs)
 {
+	printf("PIGraphicQuartz::DrawVerticalString   NOT IMPLEMENTED\n");
 /*
   int fh, fasc, fdes;
@@ -693,4 +701,5 @@
 void PIGraphicQuartz::SelLine(PILineAtt const& att)
 {
+	printf("PIGraphicQuartz::SelLine   NOT IMPLEMENTED\n");
 
 if (att == mLAtt)  return;
Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.h	(revision 4082)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.h	(revision 4083)
@@ -52,4 +52,5 @@
   virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
                                 int sx, int sy, PIColorMap* cmap);
+  virtual void	     DrawPixmap(PIGrCoord, PIGrCoord, PIPixColIdx&, PIColorMap*);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/Tests/xp1.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/xp1.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/Tests/xp1.cc	(revision 4083)
@@ -10,5 +10,9 @@
 #include PISTDWDG_H 
 #include PIWIN_H
-#include "PIButtonQuartz.h"
+#ifdef __PIWQUARTZ__
+#include <pistdwdgquartz.h>
+#else
+#include <pistdwdgx.h>
+#endif
 
 //  ----- Declaration de la classe ArgsWind : Fenetre de dialogue -------
@@ -48,10 +52,12 @@
 {
 int bsx, bsy;
-
+		printf("ArgsWind::ArgsWind\n");
+	
 // On definit la taille a partir de la taille par defaut des composantes 
 PIApplicationPrefCompSize(bsx, bsy);
 // On redefinit la taille de la fenetre
 SetSize(bsx*4, bsy*4);
-
+	printf("bsx:%d bsy:%d\n",bsx,bsy);
+	
 // Creation de champs "labels"
 mLab[0] = new PILabel(this, "Arg-1:", bsx, bsy, bsx/3, bsy/4); 
@@ -96,4 +102,5 @@
 void ArgsWind::Process(PIMessage msg, PIMsgHandler* /*sender*/, void* /*data*/)
 {
+	printf("ArgsWind::Process\n");
 
 switch (UserMsg(msg))
Index: /trunk/SophyaPI/PI/lut.cc
===================================================================
--- /trunk/SophyaPI/PI/lut.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/lut.cc	(revision 4083)
@@ -12,13 +12,22 @@
 #include "lut.h"
 
-
+//++
+// Class	LUT
+// Lib		PI
+// include	lut.h
+//
+//	Classe Look-Up table : transformation de valeurs (intensite/RGB) en index de couleur
+//--
+//++
+// Links	Voir aussi
+// PIColorMap
+// PIPixmap
+// PIImage
+//--
 /* --Methode-- */
 
-LUT::LUT(double min, double max, unsigned short ncol, int typ, int ntable) 
+LUT::LUT(double min, double max, unsigned short ncol, int typ) 
 {
-int nlev;
-
-bornes=NULL;
-nlev = ncol-2;
+int nlev = ncol-2;
 if (nlev < 1)  nlev = 1;
 bornes = new double[nlev+1];
@@ -26,4 +35,12 @@
 if (bornes == NULL)  return;
 type = typ;  nLevel = nlev;
+int qqq = 1;
+quantum = 1;
+for(quantum=2; quantum<=42; quantum++) {
+  qqq = quantum*quantum*quantum;
+  if (qqq > NCol())  break;
+}
+quantum--;
+
 table = NULL;  
 tablenbin = 0;
@@ -39,22 +56,45 @@
 delete[] table;
 }
+/* --Methode-- */
+void LUT::SetNCol(unsigned short ncol)
+{
+if (ncol == NCol())  return;
+double min = Min();
+double max = Max();
+if (bornes) delete[] bornes;
+int nlev = ncol-2;
+if (nlev < 1)  nlev = 1;
+bornes = new double[nlev+1];
+nLevel = nlev;
+int qqq = 1;
+quantum = 1;
+for(quantum=2; quantum<=42; quantum++) {
+  qqq = quantum*quantum*quantum;
+  if (qqq > NCol())  break;
+}
+quantum--;
+// printf("*DBG*LUT* quantum= %d \n", (int)quantum);
+SetLut(min, max, Type());
+}
 
 /* --Methode-- */
-void LUT::SetLut(double min, double max, int typ, int ntable)
+void LUT::SetLut(double min, double max, int typ)
 {
 
 if(  (typ != kLutType_Lin)  && (typ != kLutType_Log)
-  && (typ != kLutType_Sqrt) && (typ != kLutType_Square)
-  )  typ = kLutType_Lin;
+  && (typ != kLutType_Sqrt) && (typ != kLutType_Square)  
+  && (typ != kLutType_RGB) )  typ = kLutType_Lin;
 type = typ;
 if (max <= min)  max = min+1.;
+mMin = min;  mMax = max;
+mMinI = (int)(min+0.1);  mMaxI = (int)(max+0.1);
 if (nLevel > 0)
   {
   int i;
-  double dx;
-  double dlx;
+  double dx, dlx, fmx;
   switch (typ)
     {
     case kLutType_Lin :
+    case kLutType_RGB :
       dx = (max-min)/(double)nLevel;
       for(i=0; i<nLevel; i++)
@@ -62,7 +102,13 @@
       break;
     case kLutType_Log :
-      dlx = log(max-min) / (double)nLevel;
+      fmx = (max-min)/(exp(1.)-1.);
+      dlx = 1./(double)nLevel;
       for(i=0; i<nLevel; i++)
-        bornes[i] = min+(double)exp((double)i*dlx);
+        bornes[i] = min+((double)exp((double)i*dlx)-1.)*fmx;
+      break;
+    case kLutType_Exp :
+      dlx = (exp(1.)-1.)/(double)nLevel;
+      for(i=0; i<nLevel; i++)
+        bornes[i] = min+(double)log(1.+(double)i*dlx)*(max-min);
       break;
     case kLutType_Sqrt :
@@ -84,5 +130,6 @@
   }
 else  bornes[0] = 0.5*(min+max);
-ComputeTable((ntable > nLevel) ? ntable : tablenbin);
+// ComputeTable((ntable > nLevel) ? ntable : tablenbin);
+if (type != kLutType_RGB) ComputeTable(0);
 return; 
 }
@@ -101,5 +148,5 @@
 
 /* --Methode-- */
-unsigned short LUT::Apply(double x)
+unsigned short LUT::ApplyI(double x)
 {
 int i;
@@ -110,12 +157,32 @@
 
 /* --Methode-- */
+unsigned short LUT::ApplyRGB(double x)
+{
+  long lv = x+0.3;
+  int r = (lv%256);
+  lv /= 256;
+  int g = (lv%256);
+  lv /= 256;
+  int b = (lv%256);
+  return (unsigned short)((Contraste(b)*quantum+Contraste(g))*quantum+Contraste(r));
+}
+
+/* --Methode-- */
 void LUT::ComputeTable(int nt)
 {
-if (nt <= 0) nt = 16*(nLevel+2);
+if (nt <= 0) { 
+  int fm = 16;
+  if ((nLevel+2)>4096) fm = 1;
+  else if ((nLevel+2)>2048) fm = 2;
+  else if ((nLevel+2)>1024) fm = 4;
+  else if ((nLevel+2)>512) fm = 8;
+  nt = fm*(nLevel+2);
+}
 else if (nt < (nLevel+2))  nt = (nLevel+2);
 tablenbin = nt;
+if (table) delete[] table;
 table = new unsigned short [nt-2];
 tablebinwidth = (Max()-Min())/(nt-2);
 double x = Min()+0.5*tablebinwidth;
-for(int i=0; i<nt-2; i++)  { table[i] = Apply(x); x += tablebinwidth; }
+for(int i=0; i<nt-2; i++)  { table[i] = ApplyI(x); x += tablebinwidth; }
 }
Index: /trunk/SophyaPI/PI/lut.h
===================================================================
--- /trunk/SophyaPI/PI/lut.h	(revision 4082)
+++ /trunk/SophyaPI/PI/lut.h	(revision 4083)
@@ -13,5 +13,5 @@
 
 // Type de lut possibles 
-enum {kLutType_Lin=1, kLutType_Log=2, kLutType_Sqrt=3, kLutType_Square=4};
+enum {kLutType_Lin=1, kLutType_Log=2, kLutType_Exp=3, kLutType_Sqrt=4, kLutType_Square=5, kLutType_RGB=11 };
 
 class LUT 
@@ -19,11 +19,36 @@
 public:
   
-  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin, int ntable=0);
+  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin);
   ~LUT();
-  void SetLut(double min, double max, int typ=kLutType_Lin, int ntable=0);
+  void SetNCol(unsigned short ncol);
+  void SetLut(double min, double max, int typ=kLutType_Lin);
   void Print();
-  unsigned short Apply(double x);
+
+  inline unsigned short Apply(double x)
+    { 
+    if (type == kLutType_RGB) return ApplyRGB(x); 
+    else return ApplyI(x);	
+    } 
+
   inline unsigned short ApplyFast(double x)
     { 
+    if (type == kLutType_RGB) return ApplyRGB(x); 
+    else return AppFast(x);	
+    } 
+
+
+  inline double Min() { return(bornes[0]); };
+  inline double Max() { return(bornes[nLevel]); };
+  inline double Borne(int k) { return(bornes[k]); };
+  inline int Type() { return(type); };
+  inline int NCol() { return(nLevel+2); };
+
+
+protected:
+  void ComputeTable(int nt);
+  unsigned short ApplyI(double x);
+  unsigned short ApplyRGB(double x);
+  inline unsigned short AppFast(double x)
+    {
     if (x < Min())  return(0);
     if (x >= Max() )  return(nLevel+1);  
@@ -31,16 +56,16 @@
     return(table[k]); 
     } 
-
-  inline double Min() { return(bornes[0]); };
-  inline double Max() { return(bornes[nLevel]); };
-  inline int Type() { return(type); };
-  inline int NCol() { return(nLevel+2); };
-
-protected:
-  void ComputeTable(int nt);
-
+  inline int  Contraste(int ii)   /* for ApplyRGB */
+    {
+    if (ii >= mMaxI) return quantum-1;
+    if (ii <= mMinI) return 0;
+    else return ((ii-mMinI)*(quantum-1)/mMaxI);
+    }	  
   int type;
   int nLevel;
+  int quantum;
   double * bornes;
+  double mMin, mMax;
+  int mMinI, mMaxI;
   int tablenbin;
   unsigned short * table;
Index: /trunk/SophyaPI/PI/parradapter.cc
===================================================================
--- /trunk/SophyaPI/PI/parradapter.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/parradapter.cc	(revision 4083)
@@ -174,4 +174,19 @@
 
 /* --Methode-- */
+double  P2DArrayAdapter::MeanVal(int ix1, int ix2, int jy1, int jy2)
+{
+int ec;
+if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
+if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
+// On calcule la somme des pixels dans la zone
+double ss = 0.;
+for(int j=jy1; j<=jy2; j++) 
+  for(int i=ix1; i<=ix2; i++)  ss += Value(i,j);
+
+ss /= (double)((jy2-jy1+1)*(ix2-ix1+1));
+return ss;  
+}   
+
+/* --Methode-- */
 void P2DArrayAdapter::XYfromxy(int ix, int iy, double& x, double& y)
 {
@@ -187,5 +202,5 @@
   double x,y;
   this->Coord(ix, iy, x, y);
-  char * isr = "";
+  const char * isr = "";
   if (ISFunc != NULL)  isr = ISFunc(this, ix, iy);
   sprintf(ibuff,"X= %g Y= %g  Pix= %g %s   ", 
@@ -433,13 +448,11 @@
 
 /* --Methode-- */
-unsigned char * P2DArrayAdapter::ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
-                int xwsz, int ywsz, unsigned char * opix, int * oxsp, int * oysp)
+void P2DArrayAdapter::ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
+                                    int xwsz, int ywsz, PIPixColIdx & pixc)
 {
 // TIMEF ; 
-unsigned char *pix, *pp, ucp;
 int zmm=1;
-int npx, npy, nppx, nppy, nszp, oszp;
+int npx, npy, nppx, nppy;
 int i,j,k,l;
-double vpx;
 
 /*
@@ -448,6 +461,7 @@
 */
 
-if ( (XSize() <= 0) || (YSize() <= 0) || (lut == NULL) || (ofx < 0) || (ofy < 0) ) 
-  { *oxsp = *oysp = 0; return(NULL); }
+if ( (XSize() <= 0) || (YSize() <= 0) || (lut == NULL) || (ofx < 0) || (ofy < 0) ) {
+  pixc.DeAlloc();  return; 
+}
 
 npx = XSize()-ofx;
@@ -471,21 +485,18 @@
   }
 
-oszp = (*oxsp)*(*oysp);
-nszp = nppx*nppy;
-if ( oszp != nszp )
-  {
-  if (opix)  delete[] opix;
-  pix = new unsigned char[nppx*nppy];
-  if (pix == NULL)  { *oxsp = *oysp = 0; ; return(NULL); }
-  }
-else  pix = opix;
-*oxsp = nppx; *oysp = nppy;
-
+
+/* printf("Debug_ComputePixmap %d %d %d (%d-%d %d-%d)\n", 
+      ofx, ofy, zm, npx,nppx, npy,nppy); */
+if (lut->NCol() <= 256) {  // On fait un pixmap de type Byte/pixel 
 /*
-printf("Debug_ComputePixmap %d %d %d (%d-%d %d-%d)\n", 
-      ofx, ofy, zm, npx,nppx, npy,nppy);
-*/
-
-pp = pix;
+printf("Debug_ComputePixmap- pixc.AllocateByte() type=%d - %d %d %d - %d %d %d - %d %d %d \n",
+  lut->Type(), 
+  lut->ApplyFast(0.), lut->ApplyFast(1.), lut->ApplyFast(2.), 
+  lut->ApplyRGB(0.), lut->ApplyRGB(1.), lut->ApplyRGB(2.), 
+  lut->Apply(0.), lut->Apply(1.), lut->Apply(2.));
+*/  
+unsigned char *pp, ucp;
+pixc.AllocateByte(nppx, nppy);
+pp = pixc.BytePointer();
 if (eXY) { // Echange Axe X,Y 
   if (zm == 1)  {  // Pas de zoom  
@@ -497,14 +508,10 @@
     }
   else if (zm < -1) {       // Compression 
-    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
-      for(i=ofx; i<ofx+npx; i+=zmm) {
-        vpx = 0;
-        for(l=0; l<zmm; l++)
-          for(k=0; k<zmm; k++)
-            vpx += this->Value( (j+l)*sgnX+offX, (i+k)*sgnY+offY);
-        *pp = (unsigned char) lut->ApplyFast(vpx/fv); 
+      for(i=ofx; i<ofx+npx; i+=zmm) { 
+        *pp = lut->ApplyFast( MeanVal(j*sgnX+offX, (j+zmm-1)*sgnX+offX, 
+                                      i*sgnY+offY, (i+zmm-1)*sgnY+offY) );
         pp++;
-        }
+      }
     }
   else  {      // Agrandissement
@@ -513,5 +520,5 @@
         ucp = (unsigned char) lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));
         for(l=0; l<zm; l++)  {
-          pp = pix+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          pp = pixc.BytePointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
           for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
 	  }
@@ -528,14 +535,10 @@
     }
   else if (zm < -1) {       // Compression 
-    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
       for(i=ofx; i<ofx+npx; i+=zmm) {
-        vpx = 0;
-        for(l=0; l<zmm; l++)
-          for(k=0; k<zmm; k++)
-            vpx += this->Value( (i+k)*sgnX+offX, (j+l)*sgnY+offY);
-        *pp = (unsigned char) lut->ApplyFast(vpx/fv); 
+        *pp = lut->ApplyFast( MeanVal(i*sgnX+offX, (i+zmm-1)*sgnX+offX, 
+                                      j*sgnY+offY, (j+zmm-1)*sgnY+offY) );
         pp++;
-        }
+      }
     }
   else  {      // Agrandissement
@@ -544,5 +547,5 @@
         ucp = (unsigned char) lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));
         for(l=0; l<zm; l++)  {
-          pp = pix+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          pp = pixc.BytePointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
           for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
 	  }
@@ -550,5 +553,65 @@
     }
   }
-return(pix);
+}  //  ---- Fin pixmap de type Byte
+else {  // On fait un pixmap de type short/pixel 
+// printf("Debug_ComputePixmap- pixc.AllocateShort() \n");
+unsigned short *pp, ucp;
+pixc.AllocateShort(nppx, nppy);
+pp = pixc.ShortPointer();
+if (eXY) { // Echange Axe X,Y 
+  if (zm == 1)  {  // Pas de zoom  
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++) {
+        *pp = lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));  pp++; 
+      }
+    }
+  else if (zm < -1) {       // Compression 
+    for(j=ofy; j<ofy+npy; j+=zmm)
+      for(i=ofx; i<ofx+npx; i+=zmm) { 
+        *pp = lut->ApplyFast( MeanVal(j*sgnX+offX, (j+zmm-1)*sgnX+offX, 
+                                      i*sgnY+offY, (i+zmm-1)*sgnY+offY) );
+        pp++;
+      }
+    }
+  else  {      // Agrandissement
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++)  {
+        ucp = lut->ApplyFast(this->Value(j*sgnX+offX, i*sgnY+offY));
+        for(l=0; l<zm; l++)  {
+          pp = pixc.ShortPointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
+	  }
+        }
+    }
+  }     // Fin du cas avec echange d'axe X/Y 
+else {
+  if (zm == 1)  {  // Pas de zoom  
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++) {
+        *pp = lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));  pp++; 
+      }
+    }
+  else if (zm < -1) {       // Compression 
+    for(j=ofy; j<ofy+npy; j+=zmm)
+      for(i=ofx; i<ofx+npx; i+=zmm) {
+        *pp = lut->ApplyFast( MeanVal(i*sgnX+offX, (i+zmm-1)*sgnX+offX, 
+                                      j*sgnY+offY, (j+zmm-1)*sgnY+offY) );
+        pp++;
+      }
+    }
+  else  {      // Agrandissement
+    for(j=ofy; j<ofy+npy; j++)
+      for(i=ofx; i<ofx+npx; i++)  {
+        ucp = lut->ApplyFast(this->Value(i*sgnX+offX, j*sgnY+offY));
+        for(l=0; l<zm; l++)  {
+          pp = pixc.ShortPointer()+((j-ofy)*zm+l)*nppx+((i-ofx)*zm);
+          for(k=0; k<zm; k++)  { *pp = ucp; pp++; }  
+	  }
+        }
+    }
+  }
+}  //  ---- Fin pixmap de type Byte
+
+return;
 }
 
Index: /trunk/SophyaPI/PI/parradapter.h
===================================================================
--- /trunk/SophyaPI/PI/parradapter.h	(revision 4082)
+++ /trunk/SophyaPI/PI/parradapter.h	(revision 4083)
@@ -9,4 +9,5 @@
 #include "machdefs.h"
 #include "lut.h"
+#include "pipixutils.h"
 
 #include <string> 
@@ -54,5 +55,7 @@
   virtual void    DefineXYCoordinates(double x0, double y0, double dx, double dy);
 // Doit etre defini par les classes derivees
-  virtual double  Value(int ix, int iy) = 0;   
+  virtual double  Value(int ix, int iy) = 0;
+// Peut etre redefini pour les classes derivees, pour une optimisation par exemple     
+  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2);   
 
   virtual void    XYfromxy(int ix, int iy, double& x, double& y);
@@ -89,7 +92,6 @@
 
 //    Calcul pixmap avec un LUT
-  virtual unsigned char * ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
-                           int xwsz, int ywsz, unsigned char * opix, 
-                           int * oxsp, int * oysp);
+  virtual void ComputePixmap(LUT* lut, int ofx, int ofy, int zm, 
+                             int xwsz, int ywsz, PIPixColIdx & pixc);
 
 //   Methode de decodage des options - Implementation par defaut ne fait rien
@@ -109,4 +111,6 @@
 };
 
+//  Adaptateur de tableau 1D pour pointeur de type T *
+
 template <class T> 
 class P1DAdapter : public P1DArrayAdapter {
@@ -126,4 +130,5 @@
 
 
+//  Adaptateur de tableau 2D pour pointeur de type T *
 template <class T> 
 class P2DAdapter : public P2DArrayAdapter {
@@ -134,7 +139,19 @@
 
   virtual 	  ~P2DAdapter() { if ( (aDel) && (mData) ) delete[] mData; }
-  virtual double   Value(int ix, int iy) 
+  virtual double  Value(int ix, int iy) 
                     {  if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
                     return(mData[ix+iy*sX]); }
+  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2)  
+    {
+    int ec;
+    if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
+    if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
+    double ss = 0.;
+    for(int j=jy1; j<=jy2; j++) 
+      for(int i=ix1; i<=ix2; i++)  ss += (double)(mData[i+j*sX]);
+    ss /= (double)((jy2-jy1+1)*(ix2-ix1+1));
+    return ss;  
+    }   
+
 protected :
   bool aDel;
@@ -142,4 +159,42 @@
 };
 
+//  Adaptateur de tableau 2D pour tableau RGB 
+
+class P2DPixRGBAdapter : public P2DArrayAdapter {
+public :
+          P2DPixRGBAdapter(PIPixRGBArray * rgbp, bool ad=false) :
+             P2DArrayAdapter(rgbp->XSize(), rgbp->YSize() )
+                { aDel = ad; mPix = rgbp; }
+  virtual ~P2DPixRGBAdapter() { if ( (aDel) && (mPix) ) delete mPix; }
+
+  virtual double  Value(int ix, int iy) 
+    {  
+    if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
+    PIPixRGB rgb = (*mPix)(ix, iy);
+    return ( ((double)rgb.blue*256.+(double)rgb.green)*256.+(double)rgb.red );
+    }
+  virtual double  MeanVal(int ix1, int ix2, int jy1, int jy2)  
+    {
+    int ec;
+    if (ix1>ix2) { ec=ix1; ix1=ix2; ix2=ec; }
+    if (jy1>jy2) { ec=jy1; jy1=jy2; jy2=ec; }    
+    int r = 0;
+    int g = 0;
+    int b = 0;
+    for(int j=jy1; j<=jy2; j++) 
+      for(int i=ix1; i<=ix2; i++)  {
+      	PIPixRGB rgb = (*mPix)(i, j);
+      	r += rgb.red;  g += rgb.green;   b += rgb.blue; 
+      }
+    int n = (jy2-jy1+1)*(ix2-ix1+1);   
+    r /= n; g /= n; b /= n;
+    return ( ((double)b*256.+(double)g)*256.+(double)r );  
+    }   
+                    
+protected :
+  bool aDel;
+  PIPixRGBArray* mPix;
+};
+
 
 
Index: /trunk/SophyaPI/PI/pi3dwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/pi3dwdg.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pi3dwdg.cc	(revision 4083)
@@ -224,6 +224,6 @@
   double ymin = mBDrw->ScaleY( mBDrw->YMin3() );
   double ymax = mBDrw->ScaleY( mBDrw->YMax3() );
-  double zmin = mBDrw->ScaleY( mBDrw->ZMin3() );
-  double zmax = mBDrw->ScaleY( mBDrw->ZMax3() );
+  double zmin = mBDrw->ScaleZ( mBDrw->ZMin3() );
+  double zmax = mBDrw->ScaleZ( mBDrw->ZMax3() );
   bool asxy = mBDrw->isAutoScaleXY();
   bool asz = mBDrw->isAutoScaleZ();
Index: /trunk/SophyaPI/PI/piapplgen.cc
===================================================================
--- /trunk/SophyaPI/PI/piapplgen.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piapplgen.cc	(revision 4083)
@@ -54,4 +54,7 @@
 #include "sopnamsp.h"
 #include "piapplgen.h"
+#include <stdlib.h>
+#include <iostream>
+#include "pidrawer.h"
 
 // Variable qui contient le pointeur de l'application courante
@@ -62,5 +65,17 @@
 :topcont(NULL), menubar(NULL), mState(0)
 {
-curapp = this;   
+  curapp = this;   
+// Si la variable d'environnement PIDEFAFSZFRAC est definie, on modifie 
+// la taille par defaut de AutoFontSizeFrac
+  char *envafsz = getenv("PIDEFAFSZFRAC");
+  if (envafsz) {
+    double fsfr = atof(envafsz);
+    if ((fsfr>0.)&&(fsfr<1.)) {
+      PIDrawer::SetGlDefAutoFontSizeFrac(fsfr);
+      cout << " PIApplicationGen()/Info: getenv(PIDEFAFSZFRAC)=" << envafsz << endl;
+      cout << "  ... Set Global Default PIDrawer AutoFontSizeFrac to " 
+           << PIDrawer::GetGlDefAutoFontSizeFrac() << endl;
+      }
+  }
 }
 
Index: /trunk/SophyaPI/PI/piapplx.cc
===================================================================
--- /trunk/SophyaPI/PI/piapplx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piapplx.cc	(revision 4083)
@@ -43,5 +43,5 @@
 class PITopContAppX : public PIContainer {
 public :
-	    	PITopContAppX(PIContainer *par, char *nom, PIWdg* topw,
+	    	PITopContAppX(PIContainer *par, const char *nom, PIWdg* topw,
                           int sx=10, int sy=10, int px=0, int py=0);
    virtual  	~PITopContAppX(); 
@@ -55,5 +55,5 @@
 
 /* --Methode-- */
-PITopContAppX::PITopContAppX(PIContainer *par, char *nom, PIWdg* topw, int sx, int sy, int px, int py)
+PITopContAppX::PITopContAppX(PIContainer *par, const char *nom, PIWdg* topw, int sx, int sy, int px, int py)
         : PIContainer(par, nom, (sx>10)?sx:10, (sy>10)?sy:10, px, py)
 {
@@ -144,6 +144,5 @@
 if (sx < sxt)  sx = sxt;
 if (sy < 10) sy = 10;
-topcont = new PITopContAppX(MBCont(), "TopLevelCont", topwdg, 
-                            sx, sy, 0, msy);
+topcont = new PITopContAppX(MBCont(), "TopLevelCont", topwdg,sx, sy, 0, msy);
 MBCont()->Show();
 //DBG printf("PIApplicationX-DBG2:: MBContSize=%d %d \n", MBCont()->XSize(), MBCont()->YSize());
@@ -289,5 +288,7 @@
 {
 int szf;
+ printf("XtAppContext* PIXtAppCtx :szx=%d szy=%d szf=%d\n",szx,szy,szf);
 PIXtAppCtx(szx, szy, szf);
+ printf("XtAppContext* PIXtAppCtx :szx=%d szy=%d szf=%d\n",szx,szy,szf);
 return;
 }
Index: /trunk/SophyaPI/PI/piaxes.cc
===================================================================
--- /trunk/SophyaPI/PI/piaxes.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piaxes.cc	(revision 4083)
@@ -11,4 +11,5 @@
 #include <math.h>
 #include "piaxes.h"
+#include "pidrawer.h"
 
 //++
@@ -41,5 +42,5 @@
 {
   ConfigureTicks();
-  ConfigureAutoFontSize();
+  ConfigureAutoFontSize(true, PIDrawer::GetGlDefAutoFontSizeFrac());
   ConfigureAxesCenter();
   setupDone = false;
@@ -53,5 +54,5 @@
 //++
 // void  DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, \
-//                  unsigned int flags=kAxesDflt, bool afsz=true)
+//                  unsigned int flags, bool afsz, double fszf)
 //	Trace les axes en utilisant les limites de l'objet PIGraphicUC. 
 //	"flags" spécifie les attributs d'axes. Constantes prédéfinies: 
@@ -64,10 +65,18 @@
 //|	      kBoxAxes | kTicks | | kIntTicks | kLabels
 //|	kGridOn, kAxesNone
-//	Si "afsz == true", la taille de fonte est choisie automatiquement.
+//	Si "afsz == true", la taille de fonte est choisie automatiquement avec "fszf" 
+//	representant la taille de fonte en fraction de (ymax-ymin)
+//
+// void DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, unsigned int flags=kAxesDflt)
+//        Appel de DrawXYAxes avec les parametres "axesAFSz. fontSz" de l'objet.
 //
 // void DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, \
 //        double xmin, double xmax, double ymin, double ymax, \
-//        unsigned int flags=kAxesDflt, bool afsz=true)
+//        unsigned int flags, bool afsz, double )
 //	Tracé d'axes avec spécification des limites d'axes.
+//
+// void DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, \
+//        double xmin, double xmax, double ymin, double ymax, unsigned int flags=kAxesDflt) 
+//        Appel de DrawXYAxes avec les parametres "axesAFSz. fontSz" de l'objet.
 //
 // void DrawXCaption(PIGraphicUC* g, string const& xLabel, PIGraphicAtt const& att)
@@ -79,10 +88,10 @@
 /* --Methode-- */
 void PIAxes::DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, 
-			unsigned int flags, bool afsz)
+			unsigned int flags, bool afsz, double fszf)
 {
   PIGrCoord xmin, xmax, ymin, ymax;
   g->GetGrSpace(xmin, xmax, ymin, ymax);
   DrawXYAxes(g, gratt, (double)xmin, (double)xmax, 
-	     (double)ymin, (double)ymax, flags, afsz);
+	     (double)ymin, (double)ymax, flags, afsz, fszf);
 }
 
@@ -90,5 +99,5 @@
 void PIAxes::DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, 
 			double xmin, double xmax, double ymin, double ymax,
-			unsigned int flags, bool afsz)
+			unsigned int flags, bool afsz, double fszf)
 
 {
@@ -107,5 +116,5 @@
 
   if(afsz) { 
-    double fsz = (yMax-yMin)*fontSz;
+    double fsz = (yMax-yMin)*fszf;
     g->SelFontSz(fsz);
   }
@@ -314,6 +323,6 @@
 //	(X/Y max-min). Les paramètres ne sont pas changés si des valeurs
 //	négatives ou nulles sont spécifiées.
-// void ConfigureAutoFontSize(double fszf=0.0125)
-//	Configuration de la taille de fonte, en mode AutoFontSize.
+// void ConfigureAutoFontSize(bool afsz=true, double fszf=0.04)
+//	Configuration de la taille de fonte, en mode AutoFontSize ou FixedFontSize.
 //	La taille est exprimée en fraction de la taille totale YMax-Min
 // void  ConfigureAxesCenter(bool fset,double x0,double y0)
@@ -332,6 +341,7 @@
 
 /* --Methode-- */
-void PIAxes::ConfigureAutoFontSize(double fszf)
-{
+void PIAxes::ConfigureAutoFontSize(bool afsz, double fszf)
+{
+  axesAFSz = afsz;
   if (fszf > 1.e-19) fontSz = fszf;
 }
@@ -420,5 +430,10 @@
     //Attention erreur d'arrondi x->0 (on code 5.1698e-26 au lieu de 0)
     double xx = (fabs(xticks[i]/xstep)<1.e-5) ? 0.: xticks[i];
-    sprintf(label,format.c_str(),xx/fac); Arrange_Label(label);
+    double dog = fabs(xx/fac);
+    if ((dog<=1.e-5)||(dog>=1.e5))  
+      sprintf(label,"%le",xx/fac);
+    else 
+      sprintf(label,format.c_str(),xx/fac); 
+    Arrange_Label(label);
     double largeur = g->CalcStringWidth(label);
     g->DUC2GrC(largeur,0.,largpix,dum);
@@ -463,5 +478,10 @@
     if(yticks[i]>yMax) break;
     double yy = (fabs(yticks[i]/ystep)<1.e-5) ? 0.: yticks[i];
-    sprintf(label,format.c_str(),yy/fac); Arrange_Label(label);
+    double dog = fabs(yy/fac);
+    if ((dog<=1.e-5)||(dog>=1.e5))  
+      sprintf(label,"%le",yy/fac);
+    else 
+      sprintf(label,format.c_str(),yy/fac); 
+    Arrange_Label(label);
     g->UC2GrC(x,yticks[i],dum,ypixdeb);   ypixdeb -= hautpix/2.;
     // -- Attention: ypix=0 est en haut de l'ecran
@@ -478,5 +498,5 @@
   if(npuiss!=0) {
     if(aYdir) hauteur = -hauteur; 
-    double ym = (aYdir)? yMin: yMax; ym = g->DeltaUCY(ym,0.5*hauteur);
+    double ym = (aYdir)? yMin: yMax; ym = g->DeltaUCY(ym,0.25*hauteur);
     sprintf(label,"%d",npuiss);
     g->DrawCompString(x,ym,"x 10",label,NULL,PI_VerticalBottom|just);
Index: /trunk/SophyaPI/PI/piaxes.h
===================================================================
--- /trunk/SophyaPI/PI/piaxes.h	(revision 4082)
+++ /trunk/SophyaPI/PI/piaxes.h	(revision 4083)
@@ -40,11 +40,15 @@
 
   virtual void      DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, 
-			       unsigned int flags=kAxesDflt, bool afsz=true);
+			       unsigned int flags, bool afsz, double fszf);
+  inline  void      DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, unsigned int flags=kAxesDflt)
+     { DrawXYAxes(g, gratt, flags, axesAFSz, fontSz); }
 
   virtual void      DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, 
 			       double xmin, double xmax, 
 			       double ymin, double ymax,
-			       unsigned int flags=kAxesDflt, bool afsz=true);
-
+			       unsigned int flags, bool afsz, double fszf);
+  inline void       DrawXYAxes(PIGraphicUC* g, PIGraphicAtt& gratt, 
+			       double xmin, double xmax, double ymin, double ymax, unsigned int flags=kAxesDflt)
+    {   DrawXYAxes(g, gratt, xmin, xmax, ymin, ymax, flags, axesAFSz, fontSz); }
 
   virtual void      DrawXCaption(PIGraphicUC* g, PIGraphicAtt& att, unsigned int flags,
@@ -56,5 +60,6 @@
   void  ConfigureTicks(int ntickx=10, int nticky=12, 
 		       double majtl=0.016, double mintl=0.01);
-  void  ConfigureAutoFontSize(double fszf=0.04);
+  //  Choix de taille automatique de fontes 
+  void  ConfigureAutoFontSize(bool afsz=true, double fszf=0.04);
   void  ConfigureAxesCenter(bool fset=false,double x0=0.,double y0=0.);
 
@@ -91,5 +96,5 @@
   bool   aXdir, aYdir;           // Sens des axes horiz, vertical 
   bool   aXlog, aYlog;           // Echelle log pour les axes horiz, vertical 
-  bool   axesAFSz;
+  bool   axesAFSz;               // true -> AutoFontSize
   
   int xNTicks, yNTicks;             // Nb de ticks en X, Y
Index: /trunk/SophyaPI/PI/piaxestools.cc
===================================================================
--- /trunk/SophyaPI/PI/piaxestools.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piaxestools.cc	(revision 4083)
@@ -237,5 +237,5 @@
   mCkb[3]->SetState(scd->isLogScaleX());
   mCkb[4]->SetState(scd->isLogScaleY());
-  mCkb[7]->SetState(scd->BaseDrawer()->isAxesAutoFontSize());
+  mCkb[7]->SetState(scd->BaseDrawer()->GetAutoFontSizeState());
   }
 else {
@@ -312,5 +312,5 @@
 
   scd->SetLogScale(mCkb[3]->GetState(), mCkb[4]->GetState() );
-  scd->BaseDrawer()->SetAxesAutoFontSize(mCkb[7]->GetState() );
+  scd->BaseDrawer()->ConfigureAutoFontSize(mCkb[7]->GetState(), -1);
   if (refr) scd->Refresh();
   return;
Index: /trunk/SophyaPI/PI/pibwdgx.cc
===================================================================
--- /trunk/SophyaPI/PI/pibwdgx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pibwdgx.cc	(revision 4083)
@@ -39,5 +39,5 @@
 CreateXtWdg(nom, piXtBaseWidgetClass, NULL, sx, sy, px, py);
 
-XtSetArg(wargs[0],PIXNobject,this); 
+XtSetArg(wargs[0],const_cast<char*>(PIXNobject),this); 
 XtSetArg(wargs[1],XtNbackground, colpixwhite);  
 XtSetArg(wargs[2],XtNborderWidth, (Dimension)0);  
@@ -72,5 +72,5 @@
 #endif
 Arg  wargs[2];
-XtSetArg(wargs[0],PIXNobject,NULL); 
+ XtSetArg(wargs[0],const_cast<char*>(PIXNobject),NULL); 
 XtSetValues(XtWdg(), wargs, 1);
 }
